--------------------------------------------------------
--Enables addon and registers events when first loaded--
--------------------------------------------------------


local frame = CreateFrame("FRAME");
frame:RegisterEvent("ADDON_LOADED");

function frame:OnEvent(event, arg1)
	if event == "ADDON_LOADED" and arg1 == "Announce" then
  		if EnabledOrDisabledBool == nil then
			EnabledOrDisabledBool = 1;
		end
  		if CapitalBool == nil then
			CapitalBool = 1;
		end
		if PartyBool == nil then
			PartyBool = 1;
		end
		if RaidBool == nil then
			RaidBool = 1;
		end
		if WhisperBool == nil then
			WhisperBool = 1;
		end
		--CreateSettingsMenu()
	end
end

frame:SetScript("OnEvent", frame.OnEvent);
local Announce = LibStub("AceAddon-3.0"):NewAddon("Announce", "AceEvent-3.0", "AceHook-3.0")
local mousetarget
function Announce:OnEnable()
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:Hooks()
end

---------------------------
--Slash commands function--
---------------------------

SLASH_ANNO1 = '/anno';

function SlashCmdList.ANNO(msg)
	if msg == "" then
		if EnabledOrDisabledBool == 1 then
			DEFAULT_CHAT_FRAME:AddMessage("Announce is ENABLED.")
		else
			DEFAULT_CHAT_FRAME:AddMessage("Announce is DISABLED.")
		end
		if CapitalBool == 1 then
			DEFAULT_CHAT_FRAME:AddMessage("Capital letters are ENABLED.")
		else
			DEFAULT_CHAT_FRAME:AddMessage("Capital letters are DISABLED.")
		end
		if PartyBool == 1 then
			DEFAULT_CHAT_FRAME:AddMessage("Party broadcast is ENABLED.")
		else
			DEFAULT_CHAT_FRAME:AddMessage("Party broadcast is DISABLED.")
		end
		if RaidBool == 1 then
			DEFAULT_CHAT_FRAME:AddMessage("Raid broadcast is ENABLED.")
		else
			DEFAULT_CHAT_FRAME:AddMessage("Raid broadcast is DISABLED.")
		end
		if WhisperBool == 1 then
			DEFAULT_CHAT_FRAME:AddMessage("Whispers are ENABLED.")
		else
			DEFAULT_CHAT_FRAME:AddMessage("Whispers are DISABLED.")
		end
		DEFAULT_CHAT_FRAME:AddMessage("/anno toggle - Toggle addon on/off.");
		DEFAULT_CHAT_FRAME:AddMessage("/anno capital - Toggle CAPITAL letters on spell names.");
		DEFAULT_CHAT_FRAME:AddMessage("/anno party - Toggle party broadcast on/off.");
		DEFAULT_CHAT_FRAME:AddMessage("/anno raid - Toggle raid broadcast on/off. Note: Will suppress party broadcast if you're in raid.");
		DEFAULT_CHAT_FRAME:AddMessage("/anno whisper - Toggle whisper on/off.");
	elseif strupper(msg) == "TOGGLE" then
		if EnabledOrDisabledBool == 0 then
			EnabledOrDisabledBool = 1;
			DEFAULT_CHAT_FRAME:AddMessage("Announce addon was enabled!");
		else
			EnabledOrDisabledBool = 0;
			DEFAULT_CHAT_FRAME:AddMessage("Announce addon was disabled!");
		end
	elseif strupper(msg) == "CAPITAL" then
		if CapitalBool == 0 then
			CapitalBool = 1;
			DEFAULT_CHAT_FRAME:AddMessage("Capital letters on spell names enabled!");
		else
			CapitalBool = 0;
			DEFAULT_CHAT_FRAME:AddMessage("Capital letters on spell names disabled!");
		end
	elseif strupper(msg) == "PARTY" then
		if PartyBool == 0 then
			PartyBool = 1;
			DEFAULT_CHAT_FRAME:AddMessage("Party broadcast enabled!");
		else
			PartyBool = 0;
			DEFAULT_CHAT_FRAME:AddMessage("Party broadcast disabled!");
		end
	elseif strupper(msg) == "RAID" then
		if RaidBool == 0 then
			RaidBool = 1;
			DEFAULT_CHAT_FRAME:AddMessage("Raid broadcast enabled!");
		else
			RaidBool = 0;
			DEFAULT_CHAT_FRAME:AddMessage("Raid broadcast disabled!");
		end
	elseif strupper(msg) == "WHISPER" then
		if WhisperBool == 0 then
			WhisperBool = 1;
			DEFAULT_CHAT_FRAME:AddMessage("Whispers enabled!");
		else
			WhisperBool = 0;
			DEFAULT_CHAT_FRAME:AddMessage("Whispers disabled!");
		end
	end
end

-----------------------------------------------------------
--Getting names for corpses of released players (Rebirth)--
-----------------------------------------------------------

function Announce:WorldFrameOnMouseDown(...)
	if(GameTooltipTextLeft1:IsVisible()) then
		local name = select(3, GameTooltipTextLeft1:GetText():find("^Corpse of (.+)$"))
		if name then
			mousetarget = name
		end
	end
	self.hooks[WorldFrame]["OnMouseDown"](...)
end

function Announce:Hooks()
	self:HookScript(WorldFrame, "OnMouseDown", "WorldFrameOnMouseDown")
end

-----------------------------------------------------
--Functions for party/raid and whispering broadcast--
-----------------------------------------------------

function Announce:SendText(spell, target)
	if (target ~= nil) then
		if PartyBool == 1 then
			local channel = "PARTY"
			if RaidBool == 1 then
				if GetNumRaidMembers() > 0 then 
					channel = "RAID"
				end
			end
			if CapitalBool == 1 then
				SendChatMessage(strupper(spell).." on "..target.."!", channel)
			else
				SendChatMessage(spell.." on "..target.."!", channel)
			end
		elseif RaidBool == 1 then
			local channel = "RAID"
			if CapitalBool == 1 then
				SendChatMessage(strupper(spell).." on "..target.."!", channel)
			else
				SendChatMessage(spell.." on "..target.."!", channel)
			end
		end
	else
		if PartyBool == 1 then
			local channel = "PARTY"
			if RaidBool == 1 then
				if GetNumRaidMembers() > 0 then 
					channel = "RAID" 
				end
			end
			if CapitalBool == 1 then
				SendChatMessage(strupper(spell).."!", channel)
			else
				SendChatMessage(spell.."!", channel)
			end
		elseif RaidBool == 1 then
			local channel = "RAID"
			if CapitalBool == 1 then
				SendChatMessage(strupper(spell).." on "..target.."!", channel)
			else
				SendChatMessage(spell.." on "..target.."!", channel)
			end
		end
	end
end

function Announce:WhisperText(spell, name)
	if WhisperBool == 1 then
		if CapitalBool == 1 then
			SendChatMessage(strupper(spell).." on you!", WHISPER, nil, name)
		else
			SendChatMessage(spell.." on you!", WHISPER, nil, name)
		end
	end
end

------------------------
--Combat log filtering--
------------------------

function Announce:COMBAT_LOG_EVENT_UNFILTERED(_,_,event,playerGUID,_,_,_,targetName,_,spellID)
	if EnabledOrDisabledBool ~= 0 then
		if (playerGUID == UnitGUID("player")) then
			if (event == "SPELL_CAST_START") then
				------------
				--Rebirths--
				------------
				if (select(2, UnitClass("player")) == "DRUID") then
					if (spellID == 20484) or (spellID == 20739) or (spellID == 20742) or (spellID == 20747) or (spellID == 20748) or (spellID == 26994) or (spellID == 48477) then 
						if (UnitIsVisible("target") and UnitName("target") and UnitIsFriend("player","target") and UnitIsDead("target")) then
							self:SendText(GetSpellInfo(spellID), UnitName("target"))
						else
							self:SendText(GetSpellInfo(spellID), mousetarget)
						end
					end
				end
			elseif (event == "SPELL_CAST_SUCCESS") then
				--------------------------------
				--Death Knight: Hungering Cold--
				--------------------------------
				if (select(2, UnitClass("player")) == "DEATHKNIGHT") then
					if (spellID == 49203) then
						self:SendText(GetSpellInfo(spellID), targetName)
					end
				end

				-------------------------------------
				--Druid: Innervate/Challenging Roar--
				-------------------------------------
				if (select(2, UnitClass("player")) == "DRUID") then
					if (spellID == 29166) then 
						self:SendText(GetSpellInfo(spellID), targetName)
						self:WhisperText(GetSpellInfo(spellID), targetName)
					elseif (spellID == 5209) then 
						self:SendText(GetSpellInfo(spellID), targetName)
					end
				end

				-----------------------------------------------
				--Warrior: Shattering Throw/Challenging Shout--
				-----------------------------------------------
				if (select(2, UnitClass("player")) == "WARRIOR") then
					if (spellID == 64382) or (spellID == 1161) then
						self:SendText(GetSpellInfo(spellID), targetName)
					end
				end

				-------------------------
				--Hunter: Master's Call--
				-------------------------
				if (select(2, UnitClass("player")) == "HUNTER") then
					if (spellID == 53271) then 
						self:SendText(GetSpellInfo(spellID), targetName)
					end
				end

				------------------------------------
				--Warlock: Demonic Circle Teleport--
				------------------------------------
				if (select(2, UnitClass("player")) == "WARLOCK") then
					if (spellID == 48020) then 
						self:SendText(GetSpellInfo(spellID), targetName)
					end
				end
			elseif (event == "SPELL_AURA_APPLIED") then
				-------------------------------------------
				--Death Knight: Strangulate/Gnaw/Hysteria--
				-------------------------------------------
				if (select(2, UnitClass("player")) == "DEATHKNIGHT") then
					if (spellID == 47476) or (spellID == 47481) then
						self:SendText(GetSpellInfo(spellID), targetName)
					elseif (spellID == 49016) then
						self:SendText(GetSpellInfo(spellID), targetName)
						self:WhisperText(GetSpellInfo(spellID), targetName)
					end
				end

				------------------
				--Druid: Cyclone--
				------------------
				if (select(2, UnitClass("player")) == "DRUID") then
					if (spellID == 33786) then
						self:SendText(GetSpellInfo(spellID), targetName)
					end
				end

				------------------------------------------------------------------------------------
				--Paladin: Repentance/Hammer of Justice/Avenger's Shield silence/Hand of Salvation--
				------------------------------------------------------------------------------------
				if (select(2, UnitClass("player")) == "PALADIN") then
					if (spellID == 20066) or (spellID == 10308) or (spellID == 63529) or (spellID == 1038) then
						self:SendText(GetSpellInfo(spellID), targetName)
					end
				end

				----------------------------------------------
				--Rogue: Dismantle/Blind/Tricks of the Trade--
				----------------------------------------------
				if (select(2, UnitClass("player")) == "ROGUE") then
					if (spellID == 51722) or (spellID == 2094) or (spellID == 57934) then
						self:SendText(GetSpellInfo(spellID), targetName)
					end
				end

				----------------------------------------------------
				--Warrior: Shield Wall/Disarm/Enraged Regeneration--
				----------------------------------------------------
				if (select(2, UnitClass("player")) == "WARRIOR") then
					if (spellID == 871) or (spellID == 676) or (spellID == 55694) then
						self:SendText(GetSpellInfo(spellID), targetName)
					end
				end

				------------------------------------------------
				--Hunter: Wywern Sting/Deterrence/Misdirection--
				------------------------------------------------
				if (select(2, UnitClass("player")) == "HUNTER") then
					if (spellID == 49012) or (spellID == 19263) or (spellID == 34477) then
						self:SendText(GetSpellInfo(spellID), targetName)
					end
				end

				-----------------------------------
				--Warlock: Soulstone Resurrection--
				-----------------------------------
				if (select(2, UnitClass("player")) == "WARLOCK") then
					if (spellID == 47883) then
						self:SendText(GetSpellInfo(spellID), targetName)
					end
				end

				---------------------------------------------------------------
				--Mage: Polymorph: Pig/Rabbit/Serpent/Turkey/Turtle/Sheep/Cat--
				---------------------------------------------------------------
				if (select(2, UnitClass("player")) == "MAGE") then
					if (spellID == 28272) or (spellID == 61721) or (spellID == 61025) or (spellID == 61780) or (spellID == 28271) or (spellID == 12826) or (spellID == 61305) then
						self:SendText(GetSpellInfo(spellID), targetName)
					end
				end

				-------------------------------------------------------------------------------------------------
				--Priest: Pain Suppression/Guardian Spirit/Power Infusion/Fear Ward/Shackle Undead/Mind Control--
				-------------------------------------------------------------------------------------------------
				if (select(2, UnitClass("player")) == "PRIEST") then
					if (spellID == 33206) or (spellID == 47788) or (spellID == 10060) or (spellID == 6346) or (spellID == 9484) or (spellID == 605) then
						self:SendText(GetSpellInfo(spellID), targetName)
					end
				end

				---------------
				--Shaman: Hex--
				---------------
				if (select(2, UnitClass("player")) == "SHAMAN") then
					if (spellID == 51514) then
						self:SendText(GetSpellInfo(spellID), targetName)
					end
				end

				-----------------------------------------------------------------------------------------
				--Whispers: Hand of Salvation/Tricks of the Trade/Soulstone Resurrection/Power Infusion--
				-----------------------------------------------------------------------------------------
				if (spellID == 1038) or (spellID == 57934) or (spellID == 47883) or (spellID == 10060) then 
					self:WhisperText(GetSpellInfo(spellID), targetName)
				end
			end
		end
	end
end
